; Afficher les sprites en utilisant la variable map
; Utilise la martrice field
; Detruit surement plein de registres :)
PRINT_FIELD:
	ld	ix, field	; charger l'adresse de la map
	ld	b, 8
	ld	e, 0


pf_loop1:
	push	bc
	ld	a, 0
	ld	b, 12
pf_loop2:
	push	bc
	ld	b, (ix)

	call	PRINT_BUBBLE
	inc	ix	
	add	a, 8
	pop	bc
	djnz	pf_loop2

	ld	hl, 8
	ld	d, 0
	add	hl, de
	ld	e, l
	
	pop	bc
	djnz	pf_loop1

	ret
; e = x
; c = y
; Or on veut
; a = x
; e = y
PRINT_BUBBLE_FROM_INDICES:
	push	af
	call	FIELD_GET
	ld	b, a	; Mettre la valeur dans b
	pop	af
		
	push	af
	sla	e	; x 2
	sla	e	; x 4
	sla	e	; x 8

	pop	af
	ld	a, c
	sla	a	; x 2
	sla	a	; x 4
	sla	a	; x 8
	ld	c, a
	ld	a, e
	ld	e, c
	; Ok here we have a = x (pixels) and e = y (pixels)

	call	PRINT_BUBBLE
	call	FASTCOPY
	ret


; a = x (en pixels)
; e = y (en pixels)
; b contient la valeur de la bulle
PRINT_BUBBLE:
	push	af
	push	de
	ld	a, b
	cp	0
	jp	z, transparent
	sub	1
	jp	z, noir
	sub	1
	jp	z, blanc
	jp	rien

transparent:
	ld	hl, gomme
	pop	de
	pop	af
	push	af
	push	de
	call	CLRSPR
	jp	rien
noir:
	ld	hl, (pointeur_sur_black)
	jp	affiche
blanc:
	ld	hl, (pointeur_sur_white)
	jp	affiche
affiche:
	pop	de
	pop	af
	push	af
	push	de

	push	hl
	push	af
	push	de

	ld	hl, gomme
	call	CLRSPR
	pop	de
	pop	af
	pop	hl
	call	DRWSPR

rien:
	pop	de
	pop	af
	ret




; Remplir le tableau de maniere aleatoire
GENERATE_FIELD:
	ld	ix, field
	ld	b, 8

gf_loop1:
	push	bc
	ld	b, 12
gf_loop2:
	push	bc
	ld	a, 2
	ld	b, a
	;ld	b, 3
	call	RANDOM_ION
	inc	a
	ld	(ix), a

	inc	ix	
	pop	bc
	djnz	gf_loop2

	pop	bc
	djnz	gf_loop1

	ret


field:
	.db 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2
	.db 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2
	.db 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2
	.db 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2
	.db 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2
	.db 2, 2, 1, 2, 2, 2, 2, 2, 2, 2, 2, 2
	.db 2, 1, 1, 1, 2, 2, 2, 2, 2, 2, 2, 2
	.db 2, 2, 1, 2, 2, 2, 2, 2, 2, 2, 2, 2

fieldbak:
	.db 1, 1, 2, 2, 3, 3, 4, 4, 1, 1, 2, 2
	.db 1, 2, 3, 4, 1, 2, 3, 4, 1, 2, 3, 4
	.db 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	.db 1, 1, 2, 2, 3, 3, 4, 4, 1, 1, 2, 2
	.db 4, 4, 3, 3, 2, 2, 1, 1, 2, 2, 3, 3
	.db 1, 1, 2, 2, 3, 3, 4, 4, 1, 1, 2, 2
	.db 4, 4, 3, 3, 2, 2, 1, 1, 2, 2, 3, 3
	.db 1, 1, 2, 2, 3, 3, 4, 4, 1, 1, 2, 2
	.db 4, 4, 3, 3, 2, 2, 1, 1, 2, 2, 3, 3


; e = x
; c = y
FIELD_SET:
	push	bc
	push	de
	push	hl
	push	af
	
	; y * 12
	ld	a, c 
	add	a, a
	add	a, a
	ld	b, a
	add	a, a
	add	a, b

	; + x
	ld	b, e
	add	a, b

	; Decalage dans le field
	ld	hl, field
	ld	d, 0
	ld	e, a
	add	hl, de
	
	pop	af
	ld	(hl), a

	pop	hl
	pop	de
	pop	bc

	ret

; e = x
; c = y
; a = la valeur de la case
FIELD_GET:
	push	bc
	push	hl
	push	de
	
	; y * 12
	ld	a, c 
	add	a, a
	add	a, a
	ld	b, a
	add	a, a
	add	a, b

	; + x
	ld	b, e
	add	a, b

	; Decalage dans le field
	ld	hl, field
	ld	d, 0
	ld	e, a
	add	hl, de

	ld	a, (hl)

	pop	de
	pop	hl
	pop	bc

	ret


