; Init the start position of the focus
FOCUS_INIT:

	; start at (16, 16)	
	ld a, 16
	ld (xcoord), a
	ld (oldxcoord), a
	ld a, 16
	ld (ycoord), a
	ld (oldycoord), a
	
	; print the focus
	call FOCUS_PRINT	

	ret

;; Scan key using direct input
MOVE_SCAN_KEY:
	;ld     a,$FF            ; Before any action, reset the keyport
        ;out    (1),a            ; ...by sending to the port 1 the value 255 (FF
	ld     a,$FE            ; select the keyboard group to scan (here the arrow keys)
	out    (1),a            ; ...by sending to the keyboard port (1) the value FE.
	in     a,(1)            ; Get the port value, which says wich keys was pressed 
	cp     254              ;\
	jp     z,bot            ;|
	cp     253              ;| Look for the key which was pressed and jump to the correct label. 
	jp     z,left           ;|
	cp     251              ;|
	jp     z,right          ;|
	cp     247              ;|
	jp     z,top           ;/
	
	jp 	aucune_touche
	
; Callback depending on key pressed	
top:
	ld	a, (mkflag)
	cp	1
	ret	z
	ld a,(ycoord)
	sub 8
	ld (ycoord),a
	jp print
bot:
	ld	a, (mkflag)
	cp	1
	ret	z
	ld a,(ycoord)
	add a,8
	ld (ycoord),a
	jp print
right:
	ld	a, (mkflag)
	cp	1
	ret	z
	ld a,(xcoord)
	add a,8
	ld (xcoord),a
	jp print
left:
	ld	a, (mkflag)
	cp	1
	ret	z
	ld a,(xcoord)
	sub 8
	ld (xcoord),a
	jp print

; Passe ici seulement si key press
print:
	ld	a, 1
	ld	(mkflag), a
	ei
	halt
	halt
	halt
	halt
	halt
	halt
	halt
	ld	a,(xcoord)
	ld 	e,(ycoord)
	call	PROTECT_ARENA

	call 	FOCUS_PRINT
	jp	finloop

aucune_touche:
	ld	a, 0
	ld	(mkflag), a

finloop:
	
	ret

mkflag:
	.db 0

; On affiche le curseur
FOCUS_PRINT:

	; effacer la tout le sprite (on l'affichera un pixel plus loin apres)	
	ld	a,(oldxcoord)
	ld 	de,(oldycoord)
	ld	d,0
	ld	hl, (pointeur_sur_focus)
	call	CLRSPR

	; afficher nouveau sprite
	ld 	hl,(xcoord)
	ld 	de,(ycoord)
	ld 	(oldxcoord),hl
	ld 	(oldycoord),de
	ld 	a,l
	ld	hl, (pointeur_sur_focus)
	call 	DRWSPR

	ret

; Cette routine permet d'eviter qu'on sorte de l'arene
PROTECT_ARENA:

	ld	a,(xcoord)
	cp 	0
	jp	m, hors_arene
	cp	96
	jp	p, hors_arene
	ld	a,(ycoord)
	cp 	0
	jp	m, hors_arene
	cp	64
	jp	p, hors_arene

	jp	place_valide

hors_arene:
	; Ici on restaure l'ancien placement (pour eviter la sortie d'arene)
	ld	a, (oldxcoord)
	ld	(xcoord), a
	ld	a, (oldycoord)
	ld	(ycoord), a

place_valide:
	
	ret


; Test if the player selects a block  
SELECT_SCAN_KEY:
	ld     a,$FF          
        out    (1),a           
	ld     a,$BF       	; scanner le groupe
	out    (1),a         
	in     a,(1)        
	;bit	0,a
	cp	223
	jp	z, select
	
	jp	rien_du_tout

	
select:
	; Verifier qu'on ne pose pas 10 tubes a la suite
	ld	a, (kflag)
	cp	0
	jp	z, ok
	jp	select_end

ok:
	; Si c'est bon activer le flag	
	ld	hl, kflag
	ld	a, 1
	ld	(hl), a 	

	call	REVERSE

select_end:

	ret

rien_du_tout:
	ld	a, 0
	ld	hl, kflag
	ld	(hl), a
	ret

DIVIDE_A_BY_EIGHT:
	srl	a
	srl	a
	srl	a
	ret


kflag:
	.db 0

; Lorsqu'on presse enter
SCAN_DEL:
        ld     a,$FF            ; Before any action, reset the keyport
        out    (1),a            ; ...by sending to the port 1 the value 255 (FF
        ld     a,$BF            ; select the keyboard group to scan (here the arrow keys)
        out    (1),a            ; ...by sending to the keyboard port (1) the value FE.
        in     a,(1)            ; Get the port value, which says wich keys was pressed 
        cp     127              ;\  
        jp     z, sd_pressed    
     
        jp sd_finloop
     
sd_pressed:
        ld      a, 1
        ld      (stop), a

sd_finloop:
     
        ret 

; Savoir si on presse del
stop:
        .db     0

